package com.fp.persistence.parmas.soli;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.sql.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMARMAS
 */
@Entity(name = "TarmArmas")
@Table(name = "TARMARMAS")
public class TarmArmas extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable, Log {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;
    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;
    /**
     * Clave primaria de la Entidad TarmArmas
     */
    @Id
    @Column(name = "CARMA", nullable = false, updatable = false)
    private String pk;
    @Column(name = "MARCA", nullable = true)

    /**
     * null
     */
    private String marca;

    @Column(name = "MARCACODIGO", nullable = true)

    /**
     * null
     */
    private String marcacodigo;

    @Column(name = "PARTIDAARANCELARIA", nullable = true)

    /**
     * Partida arancelaria
     */
    private String partidaarancelaria;

    @Column(name = "PARTIDAARANCELARIACODIGO", nullable = true)

    /**
     * Partida arancelaria codigo
     */
    private String partidaarancelariacodigo;

    @Column(name = "TIPOFABRICACION", nullable = true)

    /**
     * null
     */
    private String tipofabricacion;

    @Column(name = "TIPOFABRICACIONCODIGO", nullable = true)

    /**
     * null
     */
    private String tipofabricacioncodigo;

    @Column(name = "COLOR", nullable = true)

    /**
     * null
     */
    private String color;

    @Column(name = "COLORCODIGO", nullable = true)

    /**
     * null
     */
    private String colorcodigo;

    @Column(name = "CPAISORIGEN", nullable = true)

    /**
     * null
     */
    private String cpaisorigen;

    @Column(name = "UNIDADMEDIDACANTIDAD", nullable = true)

    /**
     * null
     */
    private String unidadmedidacantidad;

    @Column(name = "UNIDADMEDIDACANTIDADCODIGO", nullable = true)

    /**
     * null
     */
    private String unidadmedidacantidadcodigo;

    @Column(name = "ESTADO", nullable = true)

    /**
     * null
     */
    private String estado;

    @Column(name = "ESTADOCODIGO", nullable = true)

    /**
     * null
     */
    private String estadocodigo;

    @Column(name = "COUNTRYCODE", nullable = true)

    /**
     * null
     */
    private String countrycode;

    @Column(name = "PROVINCECODE", nullable = true)

    /**
     * null
     */
    private String provincecode;

    @Column(name = "CANTONCODE", nullable = true)

    /**
     * null
     */
    private String cantoncode;

    @Column(name = "PARROQUIACODE", nullable = true)

    /**
     * null
     */
    private String parroquiacode;

    @Column(name = "CREGISTRO", nullable = true)

    /**
     * null
     */
    private Long cregistro;

    @Column(name = "CITYCODE", nullable = true)

    /**
     * null
     */
    private String citycode;

    @Column(name = "LOTE", nullable = true)

    /**
     * null
     */
    private String lote;

    @Column(name = "CANTIDAD", nullable = true)

    /**
     * null
     */
    private Integer cantidad;

    @Column(name = "PESO", nullable = true)

    /**
     * null
     */
    private BigDecimal peso;

    @Column(name = "MODELO", nullable = true)

    /**
     * null
     */
    private String modelo;

    @Column(name = "SERIECANON", nullable = true)

    /**
     * null
     */
    private String seriecanon;

    @Column(name = "FEMISIONPERMISO", nullable = true)

    /**
     * null
     */
    private Date femisionpermiso;

    @Column(name = "DIRECCION", nullable = true)

    /**
     * null
     */
    private String direccion;

    @Column(name = "NEMONICOARMA", nullable = true)

    /**
     * null
     */
    private String nemonicoarma;

    @Column(name = "FECHAREGISTRO", nullable = true)

    /**
     * null
     */
    private Date fecharegistro;

    @Column(name = "RECORDVERSION", nullable = true)

    /**
     * null
     */
    private Integer recordversion;

    @Column(name = "CTIPOARMAEXPLOSIVO", nullable = true)

    /**
     * null
     */
    private String ctipoarmaexplosivo;

    @Column(name = "CODIGOARMA", nullable = true)

    /**
     * Codigo identificador de arma
     */
    private String codigoarma;

    @Column(name = "FDESADUANIZACION", nullable = true)

    /**
     * null
     */
    private Date fdesaduanizacion;

    @Column(name = "ESTADODECOMISO", nullable = true)

    /**
     * null
     */
    private String estadoDecomiso;

    @Column(name = "ESTADOVENTA", nullable = true)

    /**
     * null
     */
    private String estadoventa;

    @Column(name = "PATHDOCUMENTO", nullable = true)

    private String pathDocumento;

    /**
     * valor auxiliar
     *
     */
    @Transient
    private int valorAux;

    /**
     * valor auxiliar
     *
     */
    @Transient
    private BigDecimal pesoAux;

    @Column(name = "FECHACADUCIDAD", nullable = true)

    /**
     * fecha de caducidad del documento habilitante
     */
    private Date fechacaducidad;

    @Column(name = "PATHDOCUMENTOCREAR", nullable = true)
    private String pathDocumentocrear;

    @Column(name = "GENERACERTIFICADO", nullable = true)
    private String generacertificado;
    
    @Column(name = "observacionmodificacion", nullable = true)
    private String observacionmodificacion;
    
    public int getValorAux() {
        return valorAux;
    }

    public void setValorAux(int valorAux) {
        this.valorAux = valorAux;
    }

    public BigDecimal getPesoAux() {
        return pesoAux;
    }

    public void setPesoAux(BigDecimal pesoAux) {
        this.pesoAux = pesoAux;
    }

    /**
     * Contructor por defecto
     */
    public TarmArmas() {
    }

    /**
     * Contructor de TarmArmas
     *
     * @param pPk Clave Primaria del entity
     */
    public TarmArmas(String pPk) {
        this();
        pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     *
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TarmArmas
     */
    public static TarmArmas find(EntityManager pEntityManager, Object pKey) throws Exception {
        TarmArmas obj = pEntityManager.find(TarmArmas.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TarmArmas
     *
     * @return El objeto que referencia a la Clave primaria de TarmArmas
     */
    public String getPk() {
        return pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TarmArmas
     *
     * @param pPk El objeto que referencia a la nueva Clave primaria de
     * TarmArmas
     */
    public void setPk(String pPk) {
        pk = pPk;
    }

    /**
     * Obtiene el valor de marca
     *
     * @return valor de marca
     */
    public String getMarca() {
        return marca;
    }

    /**
     * Fija el valor de marca
     *
     * @param pMarca nuevo Valor de marca
     */
    public void setMarca(String pMarca) {
        marca = pMarca;
    }

    /**
     * Obtiene el valor de marcacodigo
     *
     * @return valor de marcacodigo
     */
    public String getMarcacodigo() {
        return marcacodigo;
    }

    /**
     * Fija el valor de marcacodigo
     *
     * @param pMarcacodigo nuevo Valor de marcacodigo
     */
    public void setMarcacodigo(String pMarcacodigo) {
        marcacodigo = pMarcacodigo;
    }

    /**
     * Obtiene el valor de tipofabricacion
     *
     * @return valor de tipofabricacion
     */
    public String getTipofabricacion() {
        return tipofabricacion;
    }

    /**
     * Fija el valor de tipofabricacion
     *
     * @param pTipofabricacion nuevo Valor de tipofabricacion
     */
    public void setTipofabricacion(String pTipofabricacion) {
        tipofabricacion = pTipofabricacion;
    }

    /**
     * Obtiene el valor de tipofabricacioncodigo
     *
     * @return valor de tipofabricacioncodigo
     */
    public String getTipofabricacioncodigo() {
        return tipofabricacioncodigo;
    }

    /**
     * Fija el valor de tipofabricacioncodigo
     *
     * @param pTipofabricacioncodigo nuevo Valor de tipofabricacioncodigo
     */
    public void setTipofabricacioncodigo(String pTipofabricacioncodigo) {
        tipofabricacioncodigo = pTipofabricacioncodigo;
    }

    /**
     * Obtiene el valor de color
     *
     * @return valor de color
     */
    public String getColor() {
        return color;
    }

    /**
     * Fija el valor de color
     *
     * @param pColor nuevo Valor de color
     */
    public void setColor(String pColor) {
        color = pColor;
    }

    /**
     * Obtiene el valor de colorcodigo
     *
     * @return valor de colorcodigo
     */
    public String getColorcodigo() {
        return colorcodigo;
    }

    /**
     * Fija el valor de colorcodigo
     *
     * @param pColorcodigo nuevo Valor de colorcodigo
     */
    public void setColorcodigo(String pColorcodigo) {
        colorcodigo = pColorcodigo;
    }

    /**
     * Obtiene el valor de cpaisorigen
     *
     * @return valor de cpaisorigen
     */
    public String getCpaisorigen() {
        return cpaisorigen;
    }

    /**
     * Fija el valor de cpaisorigen
     *
     * @param pCpaisorigen nuevo Valor de cpaisorigen
     */
    public void setCpaisorigen(String pCpaisorigen) {
        cpaisorigen = pCpaisorigen;
    }

    /**
     * Obtiene el valor de unidadmedidacantidad
     *
     * @return valor de unidadmedidacantidad
     */
    public String getUnidadmedidacantidad() {
        return unidadmedidacantidad;
    }

    /**
     * Fija el valor de unidadmedidacantidad
     *
     * @param pUnidadmedidacantidad nuevo Valor de unidadmedidacantidad
     */
    public void setUnidadmedidacantidad(String pUnidadmedidacantidad) {
        unidadmedidacantidad = pUnidadmedidacantidad;
    }

    /**
     * Obtiene el valor de unidadmedidacantidadcodigo
     *
     * @return valor de unidadmedidacantidadcodigo
     */
    public String getUnidadmedidacantidadcodigo() {
        return unidadmedidacantidadcodigo;
    }

    /**
     * Fija el valor de unidadmedidacantidadcodigo
     *
     * @param pUnidadmedidacantidadcodigo nuevo Valor de unidadmedidacantidadcodigo
     */
    public void setUnidadmedidacantidadcodigo(String pUnidadmedidacantidadcodigo) {
        unidadmedidacantidadcodigo = pUnidadmedidacantidadcodigo;
    }

    /**
     * Obtiene el valor de estado
     *
     * @return valor de estado
     */
    public String getEstado() {
        return estado;
    }

    /**
     * Fija el valor de estado
     *
     * @param pEstado nuevo Valor de estado
     */
    public void setEstado(String pEstado) {
        estado = pEstado;
    }

    /**
     * Obtiene el valor de estadocodigo
     *
     * @return valor de estadocodigo
     */
    public String getEstadocodigo() {
        return estadocodigo;
    }

    /**
     * Fija el valor de estadocodigo
     *
     * @param pEstadocodigo nuevo Valor de estadocodigo
     */
    public void setEstadocodigo(String pEstadocodigo) {
        estadocodigo = pEstadocodigo;
    }

    /**
     * Obtiene el valor de countrycode
     *
     * @return valor de countrycode
     */
    public String getCountrycode() {
        return countrycode;
    }

    /**
     * Fija el valor de countrycode
     *
     * @param pCountrycode nuevo Valor de countrycode
     */
    public void setCountrycode(String pCountrycode) {
        countrycode = pCountrycode;
    }

    /**
     * Obtiene el valor de provincecode
     *
     * @return valor de provincecode
     */
    public String getProvincecode() {
        return provincecode;
    }

    /**
     * Fija el valor de provincecode
     *
     * @param pProvincecode nuevo Valor de provincecode
     */
    public void setProvincecode(String pProvincecode) {
        provincecode = pProvincecode;
    }

    /**
     * Obtiene el valor de cantoncode
     *
     * @return valor de cantoncode
     */
    public String getCantoncode() {
        return cantoncode;
    }

    /**
     * Fija el valor de cantoncode
     *
     * @param pCantoncode nuevo Valor de cantoncode
     */
    public void setCantoncode(String pCantoncode) {
        cantoncode = pCantoncode;
    }

    /**
     * Obtiene el valor de parroquiacode
     *
     * @return valor de parroquiacode
     */
    public String getParroquiacode() {
        return parroquiacode;
    }

    /**
     * Fija el valor de parroquiacode
     *
     * @param pParroquiacode nuevo Valor de parroquiacode
     */
    public void setParroquiacode(String pParroquiacode) {
        parroquiacode = pParroquiacode;
    }

    /**
     * Obtiene el valor de cregistro
     *
     * @return valor de cregistro
     */
    public Long getCregistro() {
        return cregistro;
    }

    /**
     * Fija el valor de cregistro
     *
     * @param pCregistro nuevo Valor de cregistro
     */
    public void setCregistro(Long pCregistro) {
        cregistro = pCregistro;
    }

    /**
     * Obtiene el valor de citycode
     *
     * @return valor de citycode
     */
    public String getCitycode() {
        return citycode;
    }

    /**
     * Fija el valor de citycode
     *
     * @param pCitycode nuevo Valor de citycode
     */
    public void setCitycode(String pCitycode) {
        citycode = pCitycode;
    }

    /**
     * Obtiene el valor de lote
     *
     * @return valor de lote
     */
    public String getLote() {
        return lote;
    }

    /**
     * Fija el valor de lote
     *
     * @param pLote nuevo Valor de lote
     */
    public void setLote(String pLote) {
        lote = pLote;
    }

    /**
     * Obtiene el valor de cantidad
     *
     * @return valor de cantidad
     */
    public Integer getCantidad() {
        return cantidad;
    }

    /**
     * Fija el valor de cantidad
     *
     * @param pCantidad nuevo Valor de cantidad
     */
    public void setCantidad(Integer pCantidad) {
        cantidad = pCantidad;
    }

    /**
     * Obtiene el valor de peso
     *
     * @return valor de peso
     */
    public BigDecimal getPeso() {
        return peso;
    }

    /**
     * Fija el valor de peso
     *
     * @param pPeso nuevo Valor de peso
     */
    public void setPeso(BigDecimal pPeso) {
        peso = pPeso;
    }

    /**
     * Obtiene el valor de modelo
     *
     * @return valor de modelo
     */
    public String getModelo() {
        return modelo;
    }

    /**
     * Fija el valor de modelo
     *
     * @param pModelo nuevo Valor de modelo
     */
    public void setModelo(String pModelo) {
        modelo = pModelo;
    }

    /**
     * Obtiene el valor de seriecanon
     *
     * @return valor de seriecanon
     */
    public String getSeriecanon() {
        return seriecanon;
    }

    /**
     * Fija el valor de seriecanon
     *
     * @param pSeriecanon nuevo Valor de seriecanon
     */
    public void setSeriecanon(String pSeriecanon) {
        seriecanon = pSeriecanon;
    }

    /**
     * Obtiene el valor de femisionpermiso
     *
     * @return valor de femisionpermiso
     */
    public Date getFemisionpermiso() {
        return femisionpermiso;
    }

    /**
     * Fija el valor de femisionpermiso
     *
     * @param pFemisionpermiso nuevo Valor de femisionpermiso
     */
    public void setFemisionpermiso(Date pFemisionpermiso) {
        femisionpermiso = pFemisionpermiso;
    }

    /**
     * Obtiene el valor de direccion
     *
     * @return valor de direccion
     */
    public String getDireccion() {
        return direccion;
    }

    /**
     * Fija el valor de direccion
     *
     * @param pDireccion nuevo Valor de direccion
     */
    public void setDireccion(String pDireccion) {
        direccion = pDireccion;
    }

    /**
     * Obtiene el valor de nemonicoarma
     *
     * @return valor de nemonicoarma
     */
    public String getNemonicoarma() {
        return nemonicoarma;
    }

    /**
     * Fija el valor de nemonicoarma
     *
     * @param pNemonicoarma nuevo Valor de nemonicoarma
     */
    public void setNemonicoarma(String pNemonicoarma) {
        nemonicoarma = pNemonicoarma;
    }

    /**
     * Obtiene el valor de fecharegistro
     *
     * @return valor de fecharegistro
     */
    public Date getFecharegistro() {
        return fecharegistro;
    }

    /**
     * Fija el valor de fecharegistro
     *
     * @param pFecharegistro nuevo Valor de fecharegistro
     */
    public void setFecharegistro(Date pFecharegistro) {
        fecharegistro = pFecharegistro;
    }

    /**
     * Obtiene el valor de recordversion
     *
     * @return valor de recordversion
     */
    public Integer getRecordversion() {
        return recordversion;
    }

    /**
     * Fija el valor de recordversion
     *
     * @param pRecordversion nuevo Valor de recordversion
     */
    public void setRecordversion(Integer pRecordversion) {
        recordversion = pRecordversion;
    }

    /**
     * Obtiene el valor de ctipoarmaexplosivo
     *
     * @return valor de ctipoarmaexplosivo
     */
    public String getCtipoarmaexplosivo() {
        return ctipoarmaexplosivo;
    }

    /**
     * Fija el valor de ctipoarmaexplosivo
     *
     * @param pCtipoarmaexplosivo nuevo Valor de ctipoarmaexplosivo
     */
    public void setCtipoarmaexplosivo(String pCtipoarmaexplosivo) {
        ctipoarmaexplosivo = pCtipoarmaexplosivo;
    }

    /**
     * Obtiene el valor de codigoarma
     *
     * @return valor de codigoarma
     */
    public String getCodigoarma() {
        return codigoarma;
    }

    /**
     * Fija el valor de codigoarma
     *
     * @param pCodigoarma nuevo Valor de codigoarma
     */
    public void setCodigoarma(String pCodigoarma) {
        codigoarma = pCodigoarma;
    }

    /**
     * Obtiene el valor de fdesaduanizacion
     *
     * @return valor de fdesaduanizacion
     */
    public Date getFdesaduanizacion() {
        return fdesaduanizacion;
    }

    /**
     * Fija el valor de fdesaduanizacion
     *
     * @param pCodigoarma nuevo Valor de fdesaduanizacion
     */
    public void setFdesaduanizacion(Date fdesaduanizacion) {
        this.fdesaduanizacion = fdesaduanizacion;
    }

    /**
     * Obtiene el valor de fechacaducidad
     *
     * @return valor de fechacaducidad
     */
    public Date getFechacaducidad() {
        return fechacaducidad;
    }

    /**
     * Fija el valor de fechacaducidad
     *
     * @param pFechacaducidad nuevo Valor de fechacaducidad
     */
    public void setFechacaducidad(Date pFechacaducidad) {
        fechacaducidad = pFechacaducidad;
    }

    public String getPartidaarancelaria() {
        return partidaarancelaria;
    }

    public void setPartidaarancelaria(String partidaarancelaria) {
        this.partidaarancelaria = partidaarancelaria;
    }

    public String getPartidaarancelariacodigo() {
        return partidaarancelariacodigo;
    }

    public void setPartidaarancelariacodigo(String partidaarancelariacodigo) {
        this.partidaarancelariacodigo = partidaarancelariacodigo;
    }

    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TarmArmas)) {
            return false;
        }
        TarmArmas that = (TarmArmas) rhs;
        if (this.getPk() == null || that.getPk() == null) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementacion del metodo hashCode de la la entidad TarmArmas
     *
     * @return el hashCode la instancia
     */
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**
     * Implementacion toString
     */
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**
     * Implementacion de la creacion de un bean en blanco TarmArmas
     */
    public Object createInstance() {
        TarmArmas instance = new TarmArmas();
        return instance;
    }

    /**
     * Clona la entidad TarmArmas
     *
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    public Object cloneMe() throws CloneNotSupportedException {
        TarmArmas p = (TarmArmas) this.clone();
        return p;
    }

    public String getEstadoDecomiso() {
        return estadoDecomiso;
    }

    public void setEstadoDecomiso(String estadoDecomiso) {
        this.estadoDecomiso = estadoDecomiso;
    }

    public String getEstadoventa() {
        return estadoventa;
    }

    public void setEstadoventa(String estadoventa) {
        this.estadoventa = estadoventa;
    }

    public String getPathDocumento() {
        return pathDocumento;
    }

    public void setPathDocumento(String pathDocumento) {
        this.pathDocumento = pathDocumento;
    }

    public String getPathDocumentocrear() {
        return pathDocumentocrear;
    }

    public void setPathDocumentocrear(String pathDocumentocrear) {
        this.pathDocumentocrear = pathDocumentocrear;
    }

    public String getGeneracertificado() {
        return generacertificado;
    }

    public void setGeneracertificado(String generacertificado) {
        this.generacertificado = generacertificado;
    }

    public String getObservacionmodificacion() {
        return observacionmodificacion;
    }

    public void setObservacionmodificacion(String observacionmodificacion) {
        this.observacionmodificacion = observacionmodificacion;
    }
    
}
